package com.example.bakery.Controllers;


import com.example.bakery.Models.Muffin;
import com.example.bakery.Repositories.MuffinRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

@Controller
public class MuffinController {

    @Autowired
    private MuffinRepository muffinRepository;

    @GetMapping
    public ResponseEntity<Iterable<Muffin>> index() {
        return new ResponseEntity<>(this.muffinRepository.findAll(), HttpStatus.OK);
    }

    @GetMapping("/{id}")
    public ResponseEntity<Muffin> show(@PathVariable Long id) {
        return new ResponseEntity<>(this.muffinRepository.findById(id), HttpStatus.OK);
    }

    @PostMapping
    public ResponseEntity<Muffin> create(@RequestParam("muffin") Muffin muffin) {
        return new ResponseEntity<>(this.muffinRepository.save(muffin), HttpStatus.CREATED);
    }

    @PutMapping("/{id}")
    public ResponseEntity<Muffin> update(@PathVariable Long id, @RequestParam("muffin") Muffin muffin) {
        Muffin foundMuffin = muffinRepository.findById(id).get();
        foundMuffin.setFlavor(muffin.getFlavor());

        return new ResponseEntity<>(this.muffinRepository.save(foundMuffin), HttpStatus.OK);
    }

    @DeleteMapping("/{id}")
    public ResponseEntity<Boolean> destroy(Long id) {
        this.muffinRepository.delete(muffinRepository.findById(id).get());
        return new ResponseEntity<>(true, HttpStatus.OK);
    }

}

